#include "StdAfx.h"
#include ".\aboutbox.h"
#include "Resource.h"

CAboutBox::CAboutBox(HWND hParent)
{
	hPrntWnd=hParent;
}

CAboutBox::~CAboutBox(void)
{
}

int CAboutBox::ShowModal()
{
	return (int)DialogBoxParam(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_ABOUTBOX),hPrntWnd,(DLGPROC)stAboutProc,(LPARAM)this);
}

LRESULT CALLBACK CAboutBox::stAboutProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static CAboutBox *pThis=NULL;
	if(uMsg==WM_INITDIALOG)
	{
		pThis=(CAboutBox*)lParam;
	}
	if (pThis!=NULL) return pThis->AboutProc(hDlg,uMsg,wParam,lParam);
	return FALSE;
}

LRESULT CALLBACK CAboutBox::AboutProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
			CenterOnParent(hDlg);
			return TRUE;
		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
	}
	return FALSE;
}

void CAboutBox::CenterOnParent(HWND hDlg)
{
	RECT rcDlg,rcPrnt;
	int x,y;
	GetWindowRect(hDlg,&rcDlg);
	GetWindowRect(hPrntWnd,&rcPrnt);
	x=rcPrnt.left+(((rcPrnt.right-rcPrnt.left)-(rcDlg.right-rcDlg.left))/2);
	y=rcPrnt.top+(((rcPrnt.bottom-rcPrnt.top)-(rcDlg.bottom-rcDlg.top))/2);
	SetWindowPos(hDlg,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}
