#ifndef MAINFRAME_H
#define MAINFRAME_H
#include <windows.h>

#define KNOWN_EXTENSIONS_COUNT 14

class CMainFrame
{
public:
	CMainFrame(HINSTANCE hInst);
	~CMainFrame(void);
	HWND Initialize();
	static LRESULT CALLBACK stWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	LRESULT CALLBACK WindowProcedure(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	BOOL Show(int CmdShow=SW_SHOW);
private:
	void ShowAboutBox();
	void OnSize(int SizeType,int ClientWdth,int ClientHght);
	void OnSomethingAsChanged(int iCtrlID);
	bool CreationState;
	void GetCurrentSettings();
	void ParseKnownExtensions(char *szStr);
	void OnApplyChanges();
	HINSTANCE p_hInst;
	HWND hWndMain,hStatBar;
	HWND hGrpBox1,hLblAll,hChkAllow[KNOWN_EXTENSIONS_COUNT];
	HWND hGrpBox2,hLblBlk,hTxtBlk;
	HWND hBtnApply,hBtnExit,hBtnAbout;
	char *szAllowed,*szBlocked,*szKnownExt[KNOWN_EXTENSIONS_COUNT];
	bool bOldState[KNOWN_EXTENSIONS_COUNT],bTmpState[KNOWN_EXTENSIONS_COUNT];
	int iOfficeVersion;
};

#endif
