// OutlookUnlock.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "MainFrame.h"
#include <CommCtrl.h>

#ifdef _DEBUG
#include <crtdbg.h>
#include <stdio.h>

void DetectMemLeaks() 
{ 
	_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF); 
	_CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE); 
	_CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
}
#endif


int APIENTRY _tWinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPTSTR lpCmdLine,int nCmdShow)
{
#ifdef _DEBUG
	DetectMemLeaks();
#endif
	InitCommonControls();
	CMainFrame frm(hInst);
	if (frm.Initialize()==NULL)
		return 0;
	frm.Show();

	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return (int) msg.wParam;
}

